﻿
@{
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section scripts{
    <script src="~/ADMIN/JS/moment.js"></script>
    <script src="~/ADMIN/JS/moment-jalaali.js"></script>
}

<style>
    #Filter input[type='radio']{
        vertical-align:sub;
    }

   #Filter .k-rtl{
       padding:15px;
       box-shadow: 0 1px 4px 0 rgba(0,0,0,.2), 0 2px 20px 0 rgba(0,0,0,.19);
   }
     #Filter label{
         margin-left: 19px;
         margin-right: 2px;
     }
      #filter_Wrapper{
          margin-bottom:10px;
      }
    #filter_Wrapper a {
   text-decoration: none;
    background-color: #666;
    cursor: pointer;
    border-radius: 29px;
    color: white;
    padding-left: 10px;
    padding-right: 10px;
    padding: 3px 10px 3px 10px;
    transition: .3s;
    margin-left: 8px;
    display: inline-block;
}

     #filter_Wrapper a i{
        font-size: 14px;
    margin-top: 3px;
    margin-right: 10px;
    float: left;
     }
   
    
</style>

<div class="wrapper-grid">
    <div id="filter_Wrapper"></div>
    @*<p id="Del_Filter" onclick="DeleteFilter()"><i style="float: left;font-size: 17px;margin-top: 1px;" class="material-icons">close</i></p>*@
    <div class="k-rtl">
        @(Html.Kendo().Grid<UserContractViewModel>()
               .Name("grid")
               .Events(e => e.DataBound("DataBound"))
               .Events(e => e.Edit("Edit"))
               .Events(e => e.DetailExpand("DetailExpand"))
               .Columns(columns =>
               {

                   columns.Bound(c => c.Time).Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 12px;font-weight: 400;" }).Title("تاریخ ثبت");
                   columns.Bound(c => c.Mobile).Title("موبایل").Width(40).HtmlAttributes(new { style = "font-size: 13px;font-weight: 300;letter-spacing: 1.6px;color: black;" });
                   columns.Bound(c => c.Email).Width(50).Title("ایمیل").HtmlAttributes(new { style = "letter-spacing:2px;font-size:11px;font-family: tahoma;" });
                   columns.Bound(c => c.ContractName).Title("قرارداد").HtmlAttributes(new { style = "font-size: 11px;overflow: hidden;text-overflow: ellipsis;white-space: nowrap;" });
                   columns.Bound(c => c.EditCount).Width(30);
                   columns.Bound(p => p.Price).HtmlAttributes(new { style = "font-weight: 500;" }).ClientTemplate(

                                                     "# if (Price == 0 || Price == null) { #" +
                                                        "<span style='color:green;'>رایگان</span>" +
                                                      "# } else { #" +
                                                          "#= kendo.toString(Price, '\\#\\#,\\#')# تومان" +
                                                      "# } #"
                                                     );
                   columns.Bound(p => p.Amount).HtmlAttributes(new { style = "font-weight: 500;" }).ClientTemplate(

                                                     "# if (Amount == 0 || Amount == null) { #" +
                                                        "<i style='color:red;vertical-align:middle;vertical-align:text-bottom;' class='material-icons'>close</i>" +
                                                      "# } else { #" +
                                                          "#= kendo.toString(Amount, '\\#\\#,\\#')# تومان" +
                                                      "# } #"
                                                     );
                  columns.Bound(p => p.Payment).HtmlAttributes(new { style = "font-weight: 500;" }).ClientTemplate(

                                                     "# if (Payment) { #" +
                                                        "<i style='color:green;vertical-align:middle;vertical-align:text-bottom;' class='material-icons'>check</i>" +
                                                      "# } else { #" +
                                                          "<i style='color:red;vertical-align:middle;vertical-align:text-bottom;' class='material-icons'>close</i>" +
                                                      "# } #"
                                                     );
                   columns.Bound(c => c.Coupon).Title("کوپن").Filterable(false);
                   columns.Command(command => { command.Edit().Text(" "); command.Destroy().Text(" "); }).Width(150);
               })
               .ToolBar(tools => tools.Excel().Text("اکسل"))
                 .ToolBar(toolbar =>
                 {
                    
                     toolbar.Custom().Text("<i class='material-icons' style='float:right;'>filter_list</i>").HtmlAttributes(new { id = "customCommand", onclick = "Filter()" });
                 })
                 .Excel(excel => excel
		             .FileName("گزارش درخواست قراردادها")
		             .Filterable(true)
		             .ProxyURL(Url.Action("Excel_Export_Save", "UserContract"))
	                 )
              .ClientDetailTemplateId("Details")
              .Editable(editable =>
              {
                  editable.Mode(GridEditMode.PopUp).Window(q => q.Width(700));
                  editable.DisplayDeleteConfirmation("آیا از حذف این ردیف اطمینان دارید ؟ ");
              }
              )
              .Pageable(pageable => pageable
                   .Refresh(true)
                   .PageSizes(true)
                   .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
                   .PageSizes(new int[] { 10, 20, 30 }))
              .Navigatable()
              .Selectable(selectable =>
              {
                  selectable.Mode(GridSelectionMode.Single);
                  selectable.Type(GridSelectionType.Row);
              })

                .Scrollable(s => s.Height("auto").Enabled(false))
              .DataSource(dataSource => dataSource
                  .Ajax()
                  .Sort(sort => sort.Add("UserContractID").Descending())
                  .Model(model => model.Id(p => p.UserContractID))
                  .Read(read => read.Action("UserContracts_Read", "UserContract").Data("filter_Data"))
                  .Update(update => update.Action("UserContracts_Update", "UserContract"))
                  .Destroy(destroy => destroy.Action("UserContracts_Destroy", "UserContract"))
              )
        )
    </div>
</div>
<script id="Details" type="text/kendo-tmpl">

    @(Html.Kendo().TabStrip()
                            .Name("tabStrip_#=UserContractID#")
                            .SelectedIndex(0)
                            .Events(q => q.Select("SelectTab"))
                            .Animation(animation => animation.Open(open => open.Fade(FadeDirection.In)))
                            .Items(items =>
                            {

                            items.Add().Text("جزئیات نسخه ها").Content(
                                @<text>
                                    <div class="k-rtl">
                                        @(Html.Kendo().Grid<UserContractViewModel>()
                                          .Name("Child_#=UserContractID#")
                                          .Events(e => e.DataBound("DataBoundPaymentLog"))
                                          .Columns(columns =>
                                          {

                                              columns.Bound(c => c.EditTime).Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 12px;font-weight: 400;" });
                                              columns.Bound(p => p.OrderId).Title("شناسه سفارش");
                                              columns.Bound(p => p.Content).ClientTemplate(

                                              "\\#if (Content == '' || Content == null) {\\#" +
                                                 "<i style='color:red;vertical-align:middle;vertical-align:text-bottom;' class='material-icons'>close</i>" +
                                               "\\# } else { \\#" +
                                                  "<a href='" + Url.Content("/Uploads/PdfFiles/") + "\\#=ApplicationUserId\\#" + "/" + "\\#=Content\\#'>" +
                                                  "<img src='" + Url.Content("/Images/file/") + "pdf.png' Title='PDF'  width='40'/></a>" +
                                               "\\# } \\#"
                                              );

                                              columns.Bound(p => p.Word).ClientTemplate(

                                              "\\#if (Word == '' || Word == null) {\\#" +
                                                 "<i style='color:red;vertical-align:middle;vertical-align:text-bottom;' class='material-icons'>close</i>" +
                                               "\\# } else { \\#" +
                                                  "<a href='" + Url.Content("/Uploads/WordFiles/") + "\\#=ApplicationUserId\\#" + "/" + "\\#=Word\\#'>" +
                                                  "<img src='" + Url.Content("/Images/file/") + "doc.png' Title='Word'  width='40'/></a>" +
                                               "\\# } \\#"
                                              );

                                              columns.Command(command => { command.Edit().Text(" "); command.Destroy().Text(" "); }).Width(150);
                                          })

                                         .ColumnMenu()
                                         .Editable(editable =>
                                         {
                                             editable.Mode(GridEditMode.PopUp).Window(q => q.Width(700));
                                             editable.DisplayDeleteConfirmation("آیا از حذف این ردیف اطمینان دارید ؟ ");
                                         }
                                         )
                                         .Pageable(pageable => pageable
                                              .Refresh(true)
                                              .PageSizes(true)
                                              .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
                                              .PageSizes(new int[] { 10, 20, 30 }))
                                         .Navigatable()
                                         .Selectable(selectable =>
                                         {
                                             selectable.Mode(GridSelectionMode.Single);
                                             selectable.Type(GridSelectionType.Row);
                                         })

                                         .Scrollable(s => s.Height("auto").Enabled(false))
                                         .DataSource(dataSource => dataSource
                                             .Ajax()

                                             .Model(model => model.Id(p => p.UserContractID))
                                             .Read(read => read.Action("UserContracts_Read", "UserContract", new { UCI = "#=UserContractID#" }))
                                             .Update(update => update.Action("UserContracts_Update", "UserContract"))
                                             .Destroy(destroy => destroy.Action("UserContracts_Destroy", "UserContract"))
                                         ).ToClientTemplate()
                                        )
                                    </div>
                                </text>
);

items.Add().Text("تراکنش").Content(

                                                                                                                                            @<text>
                                                                                                                                                <div class="wrapper-grid">
                                                                                                                                                    <div class="k-rtl">
                                                                                                                                                        @(Html.Kendo().Grid<PaymentLog>()
                                                                                                                                                       .Name("PaymentLog_#=UserContractID#")
                                                                                                                                                       .Events(e => e.DataBound("DataBoundPaymentLog"))
                                                                                                                                                       .Events(e => e.Edit("EditPaymentLog"))

                                                                                                                                                       .Columns(columns =>
                                                                                                                                                       {

                                                                                                                                                           columns.Bound(c => c.PaymentLogID).Title("شناسه");
                                                                                                                                                           columns.Bound(c => c.ReferenceBank).Title("بانک");
                                                                                                                                                           columns.Bound(c => c.IsSuccessful).Title("وضعیت پرداخت");
                                                                                                                                                           columns.Bound(c => c.RequestStatus).Title("وضعیت درخواست");
                                                                                                                                                           columns.Bound(c => c.ResponseCode).Title("کد پاسخ");
                                                                                                                                                           columns.Bound(c => c.Time).Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 12px;" }).Title("تاریخ ثبت");
                                                                                                                                                           columns.Bound(c => c.Amount).Title("مبلغ").Format("{0:n0} تومان");
                                                                                                                                                           columns.Bound(c => c.ResponseMessage).Title("پیام پاسخ");
                                                                                                                                                           columns.Command(command => { command.Edit().Text(" "); command.Destroy().Text(" "); }).Width(150);
                                                                                                                                                       })

                                                                                                                                                      .Groupable()
                                                                                                                                                      .ColumnMenu()
                                                                                                                                                      .Editable(editable =>
                                                                                                                                                      {
                                                                                                                                                          editable.Mode(GridEditMode.PopUp).Window(q => q.Width(700));
                                                                                                                                                          editable.DisplayDeleteConfirmation("آیا از حذف این ردیف اطمینان دارید ؟ ");
                                                                                                                                                      }
                                                                                                                                                      )
                                                                                                                                                      .Pageable(pageable => pageable
                                                                                                                                                           .Refresh(true)
                                                                                                                                                           .PageSizes(true)
                                                                                                                                                           .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
                                                                                                                                                           .PageSizes(new int[] { 10, 20, 30 }))
                                                                                                                                                      .Navigatable()
                                                                                                                                                      .Selectable(selectable =>
                                                                                                                                                      {
                                                                                                                                                          selectable.Mode(GridSelectionMode.Single);
                                                                                                                                                          selectable.Type(GridSelectionType.Row);
                                                                                                                                                      })
                                                                                                                                                      .Sortable(sortable =>
                                                                                                                                                      {
                                                                                                                                                          sortable.SortMode(GridSortMode.SingleColumn);
                                                                                                                                                      })
                                                                                                                                                      .Filterable()
                                                                                                                                                        .Scrollable(s => s.Height("auto").Enabled(false))
                                                                                                                                                      .DataSource(dataSource => dataSource
                                                                                                                                                          .Ajax()
                                                                                                                                                          .Sort(sort => sort.Add("PaymentLogID").Descending())
                                                                                                                                                          .Model(model => model.Id(p => p.PaymentLogID))
                                                                                                                                                          .Read(read => read.Action("PaymentLogs_Read", "PaymentLog", new { UserContractId = "#=UserContractID#" }))
                                                                                                                                                          .Update(update => update.Action("PaymentLogs_Update", "PaymentLog"))
                                                                                                                                                          .Destroy(destroy => destroy.Action("PaymentLogs_Destroy", "PaymentLog"))
                                                                                                                                                      )
                                                                                                                                                      .ToClientTemplate()
                                                                                                                                                        )
                                                                                                                                                    </div>
                                                                                                                                                </div>
                                                                                                                                            </text>
                                 );


                                 })

                                 .ToClientTemplate()
    )

</script>


<script type="text/x-kendo-template" id="Filter-Template">
    <div style="direction:rtl;">
        <p style="font-weight:bold;color:rgb(33, 150, 243)">فیلتر بر اساس قیمت قرارداد : </p>
        <p class="k-rtl">
            <input type="radio" name="Cont" id="Cont-Free" value="1" />
            <label for="Cont-Free">رایگان</label>

            <input type="radio" name="Cont" id="Cont-Price" value="0" />
            <label for="Cont-Price">غیر رایگان</label>
        </p>
        <p style="font-weight:bold;color:rgb(33, 150, 243)">فیلتر بر اساس وضعیت پرداخت : </p>
        <p class="k-rtl">
            <input type="radio" name="payment" id="Payment-true" value="1" />
            <label for="Payment-true">پرداخت شده</label>

            <input type="radio" name="payment" id="Payment-false" value="0" />
            <label for="Payment-false">پرداخت نشده</label>
        </p>

        <p style="float:right;">
            <button id="Filter_P" style="width:100%;" class="waves-effect waves-green btn" onclick="FilterPro()">فیلتر</button>
        </p>
    </div>
</script>

@(Html.Kendo().Window().Name("Filter")
    .Title("جستجو در قراردادها")
    .Visible(false)
    .Modal(true)
    .Draggable(true)
    .Width(500)
)

 <script>
      var detailsTemplate = kendo.template($("#Filter-Template").html());
 </script>


<script>

    function Filter() {      
        var wnd = $("#Filter").data("kendoWindow");
        wnd.content(detailsTemplate);
        wnd.center().open();
    }

    function FilterPro() {

        console.log($("input[name='Cont']:checked").val()) 
        console.log($("input[name='payment']:checked").val()) 
                      
            var grid = $("#grid").data("kendoGrid");

             grid.dataSource.read({
                 contractPrice :  $("input[name='Cont']:checked").val(),
                 PaymentStatus :  $("input[name='payment']:checked").val()
             });
                              
            var wnd = $("#Filter").data("kendoWindow");
            wnd.center().close();

            if($("input[name='Cont']:checked").val() !== undefined)
            {
                $("#filter_Wrapper p#Price").remove();
               
                 $("#filter_Wrapper").append(
                     '<a id="Price" onclick="DeleteFilter(this)"><i class="material-icons">close</i>قیمت</a>'
                 )
            }
            if ($("input[name='payment']:checked").val() !== undefined)
            {
                $("#filter_Wrapper p#Payment").remove();
               
                 $("#filter_Wrapper").append(
                     '<a onclick="DeleteFilter(this)" id="Payment"><i class="material-icons">close</i>وضعیت پرداخت</a>'
                 )
            }
                          
     } 
    function DeleteFilter(el) {

        if ($(el).attr("id") === 'Price')
        {
             $("input[name='Cont']:checked").attr("value" , "");

               var grid = $("#grid").data("kendoGrid");
               grid.dataSource.query({
                    page: 1,
                    pageSize: 10
               });
        
               $(el).hide()
        }
        if ($(el).attr("id") === 'Payment')
        {
             $("input[name='payment']:checked").attr("value" , "");

               var grid = $("#grid").data("kendoGrid");
               grid.dataSource.query({
                    page: 1,
                    pageSize: 10
               });
        
               $(el).hide()
        }   
    }

    function filter_Data(e) {
        return {
            contractPrice :   $("input[name='Cont']:checked").val(),
            PaymentStatus :   $("input[name='payment']:checked").val()
        }
    }
    
   
    function DataBound(e) {
        var grid = this;
        grid.tbody.find("tr[role='row']").each(function (index, value) {
            var model = grid.dataItem(this);
            $(this).find('td').each(function (index, value) {
                if ($(this).text().includes(":") && $(this).text().includes("-")) {
                    var result = moment($(this).text(), 'YYYY-M-D HH:mm:ss')
                        .format('jYYYY/jM/jDD HH:mm:ss')
                    result = result.replace(' ', '\n');
                    $(this).text(result)
                }
            })
        });
    }
    function Edit(e) {

        $(e.container["0"].firstChild.children[0]).hide();
        $(e.container["0"].firstChild.children[1]).hide();

        var kendoWindow = e.container.data("kendoWindow");
        if (e.model.isNew()) {
            kendoWindow.setOptions({
                title: ""
            });
        } else {
            kendoWindow.setOptions({
                title: "مشاهده جزئیات بیشتر"
            });
        }

    }
    function DetailExpand(e) {
        this.collapseRow(this.tbody.find(' > tr.k-master-row').not(e.masterRow));
    }
    function SelectTab(e) {
    }
    function DataBoundPaymentLog(e) {
        var grid = this;
        grid.tbody.find("tr[role='row']").each(function (index, value) {
            var model = grid.dataItem(this);

            grid.tbody.find("tr[role='row']").each(function (index, value) {
                var model = grid.dataItem(this);
                $(this).find('td').each(function (index, value) {
                    if ($(this).text().includes(":") && $(this).text().includes("-")) {
                        var result = moment($(this).text(), 'YYYY-M-D HH:mm:ss')
                            .format('jYYYY/jM/jDD HH:mm:ss')
                        result = result.replace(' ', '\n');
                        $(this).text(result)
                    }
                })
            });
        });
    }
    function EditPaymentLog(e) {

    }

   
</script>